﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using Helper;
using Helper.CustomControl;
using Xceed.Wpf.Toolkit;
using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using System.Windows.Forms;

//Helper classes created for basic functions



namespace SmartCopy
{
    /// <summary>
    /// Interaction logic for CopyForward.xaml
    /// </summary>
    public partial class CopyForward : Window
    {
        #region "Variables and Constructor"

        BusinessLayer obj_BL = new BusinessLayer();
        public DataTable dtStructureNote = new DataTable();
        public DataTable dtOutput = new DataTable();
        public string BabyType = string.Empty;
        public string FetchDoc = string.Empty;
        public string TargetDocument = string.Empty;

        public CopyForward(string BabyType1, string document_name, string Current_Fetch_Doc)
        {
            try
            {
                BabyType = BabyType1;
                TargetDocument = document_name;
                FetchDoc = Current_Fetch_Doc;

                InitializeComponent();
                double ClientResolution_Width = System.Windows.SystemParameters.PrimaryScreenWidth;
                double ClientResolution_Height = System.Windows.SystemParameters.PrimaryScreenHeight;
                this.Width = ClientResolution_Width;
                this.Height = ClientResolution_Height - 30;
                btnConfirmCopy.IsEnabled = false;
            }
            catch (Exception ex)
            {

                System.Windows.Forms.MessageBox.Show(ex.Message);
                System.Windows.Forms.MessageBox.Show(ex.InnerException.Message);
            }
        }

        #endregion

        #region Events

        /// <summary>
        /// Load event. Binding Treview for available documents
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            try
            {
                dtStructureNote = TestDataTableDoc();
                //dtStructureNote = obj_BL.FillStructuredNoteTreeView(BabyType, FetchDoc);
                lvDocument.DataContext = dtStructureNote; //TestDataTableDoc();//dtStructureNote;
            }
            catch (Exception ex)
            {

                System.Windows.Forms.MessageBox.Show(ex.Message);
                System.Windows.Forms.MessageBox.Show(ex.InnerException.Message);
            }
        }

        /// <summary>
        /// Bind observation grid for selected document 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void lvDocument_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            try
            {

                dynamic selectedItem = lvDocument.SelectedItem;

                if (selectedItem != null)
                {

                    string DocumentName = ((DataRowView)selectedItem).Row["DocumentName"].ToString();

                    long DocumentGUID = 0;
                    long.TryParse(((DataRowView)selectedItem).Row["DocumentGUID"].ToString().Trim(), out DocumentGUID);

                    long PatCareDocGUID = 0;
                    long.TryParse(((DataRowView)selectedItem).Row["PatCareDocGUID"].ToString().Trim(), out PatCareDocGUID);
                    DataTable dtObsTree = TestDataTableObs();
                    //DataTable dtObsTree = obj_BL.FillChartedObservationRichTextBox(DocumentName, PatCareDocGUID, DocumentGUID, BabyType, TargetDocument);
                    dgObservation.DataContext = dtObsTree;  ////dtObsTree;

                }
                else
                {
                    dgObservation.DataContext = null;
                }
            }
            catch (Exception ex)
            {

                System.Windows.Forms.MessageBox.Show(ex.Message);
                System.Windows.Forms.MessageBox.Show(ex.InnerException.Message);
            }


        }

        /// <summary>
        /// Copy Selected Observations
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnCopy_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (dgObservation.SelectedItems.Records.Count > 0)
                {
                    ShowSelectedObservation();
                    TabItem ti = tab_Main.Items[1] as TabItem;
                    ti.IsSelected = true;
                    btnConfirmCopy.IsEnabled = true;
                }
                else
                {
                    System.Windows.Forms.MessageBox.Show("Please select atleast one observation to copy.");
                }
            }
            catch (Exception ex)
            {

                System.Windows.Forms.MessageBox.Show(ex.Message);
                System.Windows.Forms.MessageBox.Show(ex.InnerException.Message);
            }

        }

        private void btnBack_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                TabItem ti = tab_Main.Items[0] as TabItem;
                ti.IsSelected = true;
                dgConfirmCopy.DataContext = null;

            }
            catch (Exception ex)
            {

                System.Windows.Forms.MessageBox.Show(ex.Message);
                System.Windows.Forms.MessageBox.Show(ex.InnerException.Message);
            }

        }

        /// <summary>
        /// Chart Selected Observations
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnConfirmCopy_Click(object sender, RoutedEventArgs e)
        {
            MLM_Interface.ParameterGUID = string.Empty;
            MLM_Interface.Value = string.Empty;

            DataTable dt = new DataTable();
            dt.Columns.Add("Section", typeof(string));
            dt.Columns.Add("Set", typeof(string));
            dt.Columns.Add("Observation", typeof(string));
            dt.Columns.Add("Value", typeof(string));


            foreach (Record rec in dgObservation.SelectedItems.Records)
            {
                DataRecord dr = rec as DataRecord;


                MLM_Interface.ParameterGUID = MLM_Interface.ParameterGUID + "||" + dr.Cells["ParameterGUID"].Value.ToString();
                MLM_Interface.Value = MLM_Interface.Value + "||" + dr.Cells["Value"].Value.ToString();


            }

            MLM_Interface.IsConfirmedCopy = true;

            this.Close();

        }

        /// <summary>
        /// Cancel copy and close window
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnCancelCopy_Click(object sender, RoutedEventArgs e)
        {
            MLM_Interface.IsConfirmedCopy = false;
            this.Close();
        }

        /// <summary>
        /// On click of group header select child records
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// 
        private void CheckBox_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Controls.CheckBox CB = ((System.Windows.Controls.CheckBox)sender);

            Change(CB);


        }

        private void Change(System.Windows.Controls.CheckBox CB)
        {
            GroupByRecordPresenter r = Utilities.GetAncestorFromType(CB as DependencyObject, typeof(GroupByRecordPresenter), false) as GroupByRecordPresenter;
            Record[] AlreadySelectedItems = new Record[dgObservation.SelectedItems.Records.Count];
            dgObservation.SelectedItems.Records.CopyTo(AlreadySelectedItems, 0);

            //if (r.Record.Tag != null && (r.Record.Tag as System.Windows.Controls.CheckBox).IsChecked == false)
            //{
            //    (r.Record.Tag as System.Windows.Controls.CheckBox).IsChecked = true;
            //}
            GroupByRecord GroupRec = r.Record as GroupByRecord;
            SetSelectionChild(CB, GroupRec, CB.IsChecked == true ? true : false);
            //SetSelectionChild(r.Record as GroupByRecord, CB.IsChecked == true);

            ExpandRecords(GroupRec, CB.IsChecked == true ? true : false);


            foreach (Record rc in AlreadySelectedItems)
            {
                if ((rc.ParentRecord != null && rc.ParentRecord == GroupRec) || (rc.ParentRecord != null && rc.ParentRecord.ParentRecord == GroupRec))
                    continue;
                else
                    rc.IsSelected = true;
            }
        }

        /// <summary>
        /// attach child checkboxes to group checkboxes
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void CheckBox_Loaded(object sender, RoutedEventArgs e)
        {
            try
            {

                GroupByRecordPresenter r = Utilities.GetAncestorFromType(sender as DependencyObject, typeof(GroupByRecordPresenter), false) as GroupByRecordPresenter;
                if (r != null)
                {

                    if (r.Record.RecordType == RecordType.GroupByField && (r.Record as GroupByRecord).ChildRecords != null)
                    {
                        HeaderRecord hRecord = r.Record as HeaderRecord;
                        GroupByRecord GR = r.Record as GroupByRecord;
                        if (GR.HasChildren)
                        {
                            foreach (Record rec in GR.ChildRecords)
                            {
                                rec.Tag = sender;
                            }
                        }
                    }
                    //else
                    //{
                    //    foreach (DataRecord rec in r.Record.RecordManager.Current)
                    //    {
                    //        rec.Tag = sender;
                    //    }
                    //}
                }

            }
            catch (Exception ex)
            {

                System.Windows.Forms.MessageBox.Show(ex.Message);
                System.Windows.Forms.MessageBox.Show(ex.InnerException.Message);
            }
        }

        private void Child_CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            GroupByRecordPresenter r = Utilities.GetAncestorFromType(sender as DependencyObject, typeof(GroupByRecordPresenter), false) as GroupByRecordPresenter;

            if (r != null && (r.Record.Tag as System.Windows.Controls.CheckBox).IsChecked == false)
            {
                (r.Record.Tag as System.Windows.Controls.CheckBox).IsChecked = true;
            }
        }

        //To set Cell's readonly property except Checkbox cell
        private void dgObservation_InitializeRecord(object sender, Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs e)
        {
            try
            {
                DataRecord dr = e.Record as DataRecord;

                if (dr != null)
                {

                    Style style = new Style(typeof(Infragistics.Windows.Editors.TextEditorBase));

                    style.Setters.Add(
                      new Setter(Infragistics.Windows.Editors.TextEditorBase.IsReadOnlyProperty, true));

                    dr.Cells["Observation"].EditorStyle = style;

                    dr.Cells["Value"].EditorStyle = style;

                }

            }
            catch (Exception ex)
            {

                System.Windows.Forms.MessageBox.Show(ex.Message);
                System.Windows.Forms.MessageBox.Show(ex.InnerException.Message);
            }


        }

        private void dgConfirmCopy_InitializeRecord(object sender, Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs e)
        {
            //foreach (Record rec in dgConfirmCopy.Records)
            //{
            //    rec.IsExpanded = true;
            //    //if (rec.RecordType == RecordType.GroupByField
            //    //         || rec.RecordType == RecordType.GroupByFieldLayout)
            //    //{
            //    //    GroupByRecord groupRecord = (GroupByRecord)rec;
            //    //    groupRecord.IsExpanded = true;
            //    //}
            //}
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            // MLM_Interface.IsConfirmedCopy = false;
        }

        private void tab_Main_SelectionChanged(Object sender, SelectionChangedEventArgs args)
        {
            if (tab_Main.SelectedIndex == 1)
            {

                if (dgConfirmCopy.Records.Count > 0)
                    btnConfirmCopy.IsEnabled = true;
                else
                    btnConfirmCopy.IsEnabled = false;

            }
        }

        #endregion

        #region "Methods"


        /// <summary>
        /// Select child record and check checkbox
        /// </summary>
        /// <param name="r"></param>
        /// <param name="operation"></param>
        void SetSelection(GroupByRecordPresenter r, bool operation)
        {



            if (r != null && r.Record.RecordType == RecordType.GroupByField)
            {


                HeaderRecord hRecord = r.Record as HeaderRecord;
                GroupByRecord GR = r.Record as GroupByRecord;

                if (GR.HasChildren)
                {
                    foreach (Record rec in GR.ChildRecords)
                    {
                        rec.IsSelected = operation;
                    }
                }
            }
            else
            {
                foreach (GroupByRecord rec in r.Record.RecordManager.Current)
                {
                    rec.IsSelected = operation;
                }
            }


        }

        /// <summary>
        /// Select child record and check checkbox
        /// </summary>
        /// <param name="GR"></param>
        /// <param name="operation"></param>
        void SetSelectionChild(System.Windows.Controls.CheckBox CB, GroupByRecord GR, bool operation)
        {

            if (GR != null)
            {

                if ((GR.RecordType == RecordType.GroupByField || GR.RecordType == RecordType.GroupByFieldLayout) && GR.ChildRecords.Count > 0)
                {

                    // GR.Tag = operation;

                    if (GR.Tag != null)
                    {

                        DependencyObject parent = VisualTreeHelper.GetParent(VisualTreeHelper.GetChild(GR.Tag as DependencyObject, 0));
                        int count = VisualTreeHelper.GetChildrenCount(parent);

                        //System.Windows.Controls.CheckBox chk = VisualTreeHelper.GetChild(
                        //                                            VisualTreeHelper.GetChild(
                        //                                                VisualTreeHelper.GetChild(
                        //                                                    VisualTreeHelper.GetChild(
                        //                                                        VisualTreeHelper.GetChild(
                        //                                                            VisualTreeHelper.GetParent(
                        //                                                                VisualTreeHelper.GetParent(
                        //                                                                    VisualTreeHelper.GetParent(
                        //                                                                        VisualTreeHelper.GetParent(
                        //                                                                            VisualTreeHelper.GetParent(CB)
                        //                                                                                                   )
                        //                                                                                               )
                        //                                                                                            )
                        //                                                                                        )
                        //                                                                                , 3)
                        //                                                                            , 0)
                        //                                                                        , 2)
                        //                                                                    , 0)
                        //                                                                , 0)
                        //                                            as System.Windows.Controls.CheckBox;
                        //System.Windows.Controls.Control ctl = VisualTreeHelper.GetChild(VisualTreeHelper.GetChild(VisualTreeHelper.GetChild(VisualTreeHelper.GetChild(VisualTreeHelper.GetChild(VisualTreeHelper.GetParent(VisualTreeHelper.GetParent(VisualTreeHelper.GetParent((VisualTreeHelper.GetParent(VisualTreeHelper.GetParent(CB)))))), 3), 0), 2), 0), 0) as System.Windows.Controls.Control;
                        // chk.IsChecked = operation;

                        //System.Windows.Controls.CheckBox ctrl = (System.Windows.Controls.CheckBox)VisualTreeHelper.GetChild(GR.Tag as DependencyObject, 0);
                        //ctrl.IsChecked = operation;

                        //if (Convert.ToBoolean(ctrl.IsChecked))
                        //{
                        //    ctrl.IsChecked = false;
                        //}
                        //else
                        //{
                        //    ctrl.IsChecked = true;
                        //}

                    }


                    foreach (Record rec in GR.ChildRecords)
                    {

                        rec.IsSelected = operation;
                        SetSelectionChild(CB, rec as GroupByRecord, operation);

                    }
                }
            }


        }

        void SetSelectionParent(GroupByRecord GR, bool operation)
        {
            if (GR != null)
            {
                if (GR.ParentRecord != null)
                {
                    GR.ParentRecord.IsSelected = operation;
                    SetSelectionParent(GR.ParentRecord as GroupByRecord, operation);
                }
            }
        }

        void ShowSelectedObservation()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Section", typeof(string));
            dt.Columns.Add("Set", typeof(string));
            dt.Columns.Add("Observation", typeof(string));
            dt.Columns.Add("Value", typeof(string));


            foreach (Record rec in dgObservation.SelectedItems.Records)
            {
                DataRecord dr = rec as DataRecord;
                DataRow dtrow = dt.NewRow();
                dtrow["Section"] = dr.Cells["SectionHeader"].Value.ToString();
                dtrow["Set"] = dr.Cells["SetHeader"].Value.ToString();
                dtrow["Observation"] = dr.Cells["Observation"].Value.ToString();
                dtrow["Value"] = dr.Cells["Value"].Value.ToString();

                dt.Rows.Add(dtrow);

            }


            dt.AcceptChanges();
            dgConfirmCopy.DataContext = dt;

            foreach (Record rec in dgConfirmCopy.Records)
            {
                ExpandRecords(rec, true);

            }
            double width = this.Width - 100;
            string rtfText = CommonUtility.DataTableToRtfTable(dt, Convert.ToInt32(width / 4) * 15);
            //rtf_DisplayObservationValues.Text = rtfText;
        }


        void ExpandRecords(Record rec, bool operation)
        {
            if (rec.RecordType == RecordType.GroupByField || rec.RecordType == RecordType.GroupByFieldLayout)
            {
                GroupByRecord groupRecord = (GroupByRecord)rec;
                foreach (Record ChildGroup in groupRecord.ChildRecords)
                {

                    ExpandRecords(ChildGroup, operation);

                    groupRecord.IsExpanded = operation;
                }

            }
        }


        #endregion

        private void GroupBySummariesPresenter_MouseRightButtonUp(object sender, MouseButtonEventArgs e)
        {
            DependencyObject dep = (DependencyObject)e.OriginalSource;

            // iteratively traverse the visual tree
            while ((dep != null) && !(dep is System.Windows.Controls.DataGridCell))
            {
                dep = VisualTreeHelper.GetParent(dep);
            }

            if (dep == null)
                return;

            //if (dep is DataGridColumnHeader)
            //{
            //    DataGridColumnHeader columnHeader = dep as DataGridColumnHeader;
            //    // do something
            //}

            if (dep is System.Windows.Controls.DataGridCell)
            {
                System.Windows.Controls.DataGridCell cell = dep as System.Windows.Controls.DataGridCell;
                // do something
            }
        }

        private void ContentControl_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {

        }

        private void MySTACK_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            System.Windows.Controls.CheckBox ctrl = (System.Windows.Controls.CheckBox)VisualTreeHelper.GetChild(sender as DependencyObject, 0);
            if (Convert.ToBoolean(ctrl.IsChecked))
            {
                ctrl.IsChecked = false;
            }
            else
            {
                ctrl.IsChecked = true;
            }
            Change(ctrl);
        }

        DataTable TestDataTableObs()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Observation", typeof(string));
            dt.Columns.Add("Value", typeof(string));
            dt.Columns.Add("SetHeader", typeof(string));
            dt.Columns.Add("SectionHeader", typeof(string));
            dt.Columns.Add("ParameterGUID", typeof(string));

            for (int i = 0; i < 2; i++)
            {
                DataRow dr = dt.NewRow();
                string Section = "Section_" + i.ToString();
                string Set = "Set_" + i.ToString();
                string Observation = "Obs_" + i.ToString();
                string Value = "val_" + i.ToString();
                string ParamGuid = "" + i.ToString();

                dr["SectionHeader"] = Section;
                dr["SetHeader"] = Set;
                dr["Observation"] = Observation;
                dr["Value"] = Value;
                dr["ParameterGUID"] = ParamGuid;
                dt.Rows.Add(dr);

                for (int j = 0; j < 2; j++)
                {
                    DataRow dr1 = dt.NewRow();
                    Set = "Set_" + (i + 1).ToString();
                    Observation = "Obs_" + j.ToString();
                    Value = "val_" + j.ToString();
                    ParamGuid = "" + j.ToString();

                    dr1["SectionHeader"] = Section;
                    dr1["SetHeader"] = Set;
                    dr1["Observation"] = Observation;
                    dr1["Value"] = Value;
                    dr1["ParameterGUID"] = ParamGuid;
                    dt.Rows.Add(dr1);
                    for (int k = 0; k < 2; k++)
                    {

                        DataRow dr2 = dt.NewRow();

                        Observation = "Obs_" + k.ToString();
                        Value = "val_" + k.ToString();
                        ParamGuid = "" + k.ToString();

                        dr2["SectionHeader"] = Section;
                        dr2["SetHeader"] = Set;
                        dr2["Observation"] = Observation;
                        dr2["Value"] = Value;
                        dr2["ParameterGUID"] = ParamGuid;
                        dt.Rows.Add(dr2);
                    }

                }

            }
            return dt;
        }

        DataTable TestDataTableDoc()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("DocumentGUID", typeof(string));
            dt.Columns.Add("PatCareDocGUID", typeof(string));
            dt.Columns.Add("DocumentName", typeof(string));



            for (int i = 0; i < 2; i++)
            {
                DataRow dr = dt.NewRow();
                string DocumentGUID = "DocumentGUID_" + i.ToString();
                string PatCareDocGUID = "PatCareDocGUID_" + i.ToString();
                string DocumentName = "DocumentName_" + i.ToString();


                dr["DocumentGUID"] = DocumentGUID;
                dr["PatCareDocGUID"] = PatCareDocGUID;
                dr["DocumentName"] = DocumentName;
                dt.Rows.Add(dr);


            }
            return dt;
        }

        #region "Commented Code"

        //public void CheckAllNodes(TreeNodeCollection nodes)
        //{
        //    foreach (TreeNode node in nodes)
        //    {
        //        node.Checked = true;
        //        CheckChildren(node, true);
        //    }
        //}

        //public void UncheckAllNodes(TreeNodeCollection nodes)
        //{
        //    foreach (TreeNode node in nodes)
        //    {
        //        node.Checked = false;
        //        CheckChildren(node, false);
        //    }
        //}

        //private void CheckChildren(TreeNode rootNode, bool isChecked)
        //{
        //    foreach (TreeNode node in rootNode.Nodes)
        //    {
        //        CheckChildren(node, isChecked);
        //        node.Checked = isChecked;
        //    }
        //}

        //private void PopulateTreeview()
        //{
        //    this.tvObservation.Items.Clear();
        //    HierarchyTrees hierarchyTrees = new HierarchyTrees();
        //    HierarchyTrees.HTree objHTree = null;

        //            DataTable dtObsTree = cfd.FillObservationTreeView();


        //           if(dtObsTree !=null && dtObsTree.Rows.Count>0)
        //           {
        //               foreach (DataRow reader in dtObsTree.Rows)
        //               {
        //                   objHTree = new HierarchyTrees.HTree();

        //                   //objHTree.LevelDepth = int.Parse(reader["LEVEL_DEPTH"].ToString());
        //                   objHTree.NodeID = int.Parse(reader["NodeID"].ToString());
        //                   objHTree.UnderParent = double.Parse(reader["ParentHeaderID"].ToString());
        //                   objHTree.NodeDescription = reader["Header"].ToString();
        //                   objHTree.Parent = double.Parse(reader["HeaderID"].ToString());
        //                   objHTree.LevelDepth = int.Parse(reader["ID"].ToString());
        //                   hierarchyTrees.Add(objHTree);
        //               }
        //            }

        //            TreeViewItem item;
        //    foreach (HierarchyTrees.HTree hTree in hierarchyTrees)
        //    {
        //        HierarchyTrees.HTree parentNode = hierarchyTrees.Find(delegate(HierarchyTrees.HTree emp) { return emp.Parent == hTree.UnderParent; });
        //        if (parentNode != null)
        //        {
        //            foreach (TreeViewItem tn in tvObservation.Items)
        //            {
        //                if (tn.DataContext == parentNode.NodeID.ToString())
        //                {
        //                    //tn.Items.Add(new TreeViewItem(hTree.NodeDescription.ToString(), hTree.NodeID.ToString()));


        //                     item = new TreeViewItem();
        //                     item.Header = hTree.NodeDescription.ToString();
        //                     item.Uid = hTree.NodeID.ToString();

        //                    tn.Items.Add(item);

        //                }
        //                if (tn.Items.Count > 0)
        //                {
        //                    foreach (TreeViewItem ctn in tn.Items)
        //                    {
        //                        RecursiveChild(ctn, parentNode.NodeID.ToString(), hTree);
        //                    }
        //                }
        //            }
        //        }
        //        else
        //        {
        //            item = new TreeViewItem();
        //            item.Header = hTree.NodeDescription.ToString();
        //            item.Uid = hTree.NodeID.ToString();

        //            tvObservation.Items.Add(item);
        //        }
        //    }
        //   // tvObservation.ExpandAll();
        //}
        //TreeViewItem item1;
        //public void RecursiveChild(TreeViewItem tn, string searchValue, HierarchyTrees.HTree hTree)
        //{
        //    if (tn.DataContext == searchValue)
        //    {
        //        item1 = new TreeViewItem();
        //        item1.Header = hTree.NodeDescription.ToString();
        //        item1.Uid = hTree.NodeID.ToString();

        //        tn.Items.Add(item1);
        //    }
        //    if (tn.Items.Count > 0)
        //    {
        //        foreach (TreeViewItem ctn in tn.Items)
        //        {
        //            RecursiveChild(ctn, searchValue, hTree);
        //        }
        //    }
        //}


        //public class HierarchyTrees : List<HierarchyTrees.HTree>
        //{
        //    public class HTree
        //    {
        //        private string m_NodeDescription;
        //        private double m_UnderParent;
        //        private double m_Parent;
        //        private int m_LevelDepth;
        //        private int m_NodeID;

        //        public int NodeID
        //        {
        //            get { return m_NodeID; }
        //            set { m_NodeID = value; }
        //        }

        //        public string NodeDescription
        //        {
        //            get { return m_NodeDescription; }
        //            set { m_NodeDescription = value; }
        //        }
        //        public double UnderParent
        //        {
        //            get { return m_UnderParent; }
        //            set { m_UnderParent = value; }
        //        }
        //        public double Parent
        //        {
        //            get { return m_Parent; }
        //            set { m_Parent = value; }
        //        }
        //        public int LevelDepth
        //        {
        //            get { return m_LevelDepth; }
        //            set { m_LevelDepth = value; }
        //        }
        //    }
        //}  

        #endregion


    }

}